searchNodes=[{"ref":"Mix.Tasks.Tix.html","title":"Mix.Tasks.Tix","type":"task","doc":"Tix is TDD tool that runs tests in an iex shell upon save of a file. This tool should be run in the root of the project directory with the following command: iex -S mix tix"},{"ref":"Mix.Tasks.Tix.html#run/1","title":"Mix.Tasks.Tix.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Tix.html","title":"Tix","type":"module","doc":"Documentation for Tix."},{"ref":"Tix.html#debug/1","title":"Tix.debug/1","type":"function","doc":""},{"ref":"Tix.html#pin/1","title":"Tix.pin/1","type":"function","doc":"Pin a test so that only this test will be executed on save."},{"ref":"Tix.html#run/0","title":"Tix.run/0","type":"function","doc":""},{"ref":"Tix.html#running?/0","title":"Tix.running?/0","type":"function","doc":""},{"ref":"Tix.html#start/0","title":"Tix.start/0","type":"function","doc":"Starts the Tix supervisor that watches the file system and runs the appropriate test(s)."},{"ref":"Tix.html#unpin/0","title":"Tix.unpin/0","type":"function","doc":"Unpin any previously pinned test."},{"ref":"Tix.FileWatcher.html","title":"Tix.FileWatcher","type":"module","doc":"This module is the main process which listens to file changes, triggers commands and notifications"},{"ref":"Tix.FileWatcher.html#child_spec/1","title":"Tix.FileWatcher.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Tix.FileWatcher.html#start_link/0","title":"Tix.FileWatcher.start_link/0","type":"function","doc":""},{"ref":"Tix.Focus.html","title":"Tix.Focus","type":"module","doc":""},{"ref":"Tix.Focus.html#scan_for_focused_test/1","title":"Tix.Focus.scan_for_focused_test/1","type":"function","doc":""},{"ref":"Tix.Focus.html#scan_for_focused_test/4","title":"Tix.Focus.scan_for_focused_test/4","type":"function","doc":""},{"ref":"Tix.PinnedTest.html","title":"Tix.PinnedTest","type":"module","doc":""},{"ref":"Tix.PinnedTest.html#child_spec/1","title":"Tix.PinnedTest.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Tix.PinnedTest.html#pin/1","title":"Tix.PinnedTest.pin/1","type":"function","doc":""},{"ref":"Tix.PinnedTest.html#pinned_test/0","title":"Tix.PinnedTest.pinned_test/0","type":"function","doc":""},{"ref":"Tix.PinnedTest.html#start_link/1","title":"Tix.PinnedTest.start_link/1","type":"function","doc":""},{"ref":"Tix.PinnedTest.html#unpin/0","title":"Tix.PinnedTest.unpin/0","type":"function","doc":""},{"ref":"Tix.Selector.html","title":"Tix.Selector","type":"module","doc":""},{"ref":"Tix.Selector.html#file_exists?/1","title":"Tix.Selector.file_exists?/1","type":"function","doc":""},{"ref":"Tix.Selector.html#is_test_file?/1","title":"Tix.Selector.is_test_file?/1","type":"function","doc":""},{"ref":"Tix.Selector.html#nearby_path/1","title":"Tix.Selector.nearby_path/1","type":"function","doc":""},{"ref":"Tix.Selector.html#possible_test_file_paths/1","title":"Tix.Selector.possible_test_file_paths/1","type":"function","doc":""},{"ref":"Tix.Selector.html#test_folder_path/1","title":"Tix.Selector.test_folder_path/1","type":"function","doc":""},{"ref":"Tix.Selector.html#tests_for_file/1","title":"Tix.Selector.tests_for_file/1","type":"function","doc":""},{"ref":"Tix.Supervisor.html","title":"Tix.Supervisor","type":"module","doc":""},{"ref":"Tix.Supervisor.html#child_spec/1","title":"Tix.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Tix.Supervisor.html#start_link/1","title":"Tix.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Tix.TestRunner.html","title":"Tix.TestRunner","type":"module","doc":""},{"ref":"Tix.TestRunner.html#before_run/1","title":"Tix.TestRunner.before_run/1","type":"function","doc":""},{"ref":"Tix.TestRunner.html#execute_test/1","title":"Tix.TestRunner.execute_test/1","type":"function","doc":""},{"ref":"Tix.TestRunner.html#output_files_executed/1","title":"Tix.TestRunner.output_files_executed/1","type":"function","doc":""},{"ref":"readme.html","title":"Tix","type":"extras","doc":"Tix Automatically re-run tests in Elixir&#39;s iex console when files are saved. It&#39;s like mix test.watch but without rebooting the application."},{"ref":"readme.html#usage","title":"Tix - Usage","type":"extras","doc":"Start an iex shell in test env with MIX_ENV=test iex -S mix and run Tix.start(). Or use the bundled mix task: MIX_ENV=test iex -S mix tix Tix recompiles and executes tests automatically. Only relevant modules (see mix xref and mix test --stale) are recompiled. The following algorithm is used to choose which test will be executed: Pinned test, if present: pin with Tix.pin({&quot;/path/to/test.exs&quot;, 23}) or use tix:focus comment (see below) Saved file is a test file (ending with _test.exs). Saved file has a test sibling (same name as saved file but with _test.exs-ending) living in the same folder. ✅ Previously executed test if none of the above matches. Pin a single test Sometimes it&#39;s useful to focus on a single test and exclude other tests from being executed. Use Tix.pin({&quot;path/to/some_test.exs&quot;, 23}) in the iex Shell so that only this one test will be executed upon save of any file in the project. This is useful if many tests are broken but you want to focus on a single test. Use Tix.unpin to restore the above selection algorithm. Other option to pin a test Place the comment tix:focus just before or inside the test to be focused on. The test below the comment will be pinned. use ExUnit.Case, async: true # tix:focus test &quot;this is the only one&quot; do assert true end Remove the comment to restore the usual test selection behaviour."},{"ref":"readme.html#installation","title":"Tix - Installation","type":"extras","doc":"The package can be installed by adding tix to your list of dependencies in mix.exs: def deps do [ {:tix, &quot;~&gt; 0.4.0&quot;, only: :test, runtime: false} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/tix."},{"ref":"readme.html#issues","title":"Tix - Issues","type":"extras","doc":"Tests are randomized with the same seed. pry session kills itself (after a timeout) and testix with it Tags like @tag :skip are considered, but not custom ones that are often defined in test_helper.ex Only the test helper at test/test_helper.exs is loaded. Other helpers should also be loaded. Currently one need to load it by hand with: TestIex.load_helper(&quot;spezifikation/test_helper.exs&quot;) Test is executed twice when the editor automatically runs the formatter (which obviously saves the file a second time)"},{"ref":"readme.html#planned-features","title":"Tix - (Planned) features","type":"extras","doc":"Usage like https://github.com/nccgroup/sobelow, eg. mix tix Run all tests Set debug breakpoints from within vs-code Run only one explicit test on file save (pin test) ✅"},{"ref":"readme.html#development","title":"Tix - Development","type":"extras","doc":"Run tests with lux. See integration_test folder."}]